/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package model;

import java.util.Iterator;

/**
 *
 * @author Gianni
 */
public class KeyAccessApparati implements Iterable<Apparato> {
  private Apparato[] apparati;

  public KeyAccessApparati(int numApparati) {
    apparati=new Apparato[numApparati];
    for (int i = 0; i < apparati.length; i++) {
      apparati[i]=new Apparato("Macchina"+(i+1));      
    }
  }
  
  public Apparato getApparato(String id) throws Exception{
    return apparati[indiceDi(id)];
  }

  private int indiceDi(String id) throws Exception{
    for (int i = 0; i < apparati.length; i++) {
      if (id.equals(apparati[i].getId())) {
        return i;
      }
      
    }
    throw new Exception("Id inesistente: "+id);
  }

  @Override
  public String toString() {
    String s= "KeyAccessApparati{" + "apparati=\n";
    for (int i = 0; i < apparati.length; i++) {
      Apparato apparato = apparati[i];
      s+="\t"+apparato+"\n";
    }
    s+="\t}\n";
    
    return s;
  }

  @Override
  public Iterator<Apparato> iterator() {
    return new Iteratore();
  }
  
  private class Iteratore implements Iterator<Apparato>{
    int current=0;

    @Override
    public boolean hasNext() {
      return current<apparati.length;
    }

    @Override
    public Apparato next() {
      return apparati[current++];
    }

    @Override
    public void remove() {
      throw new UnsupportedOperationException("Not supported yet.");
    }
    
  }
  
  
}
