/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package model;

/**
 *
 * @author Gianni
 */
public class ControlloOperativo {
  private KeyAccessApparati apparati;
  private final int NUMAPPARATI = 5;

  public ControlloOperativo() {
    apparati = new KeyAccessApparati(NUMAPPARATI);
  }
  
  public void comandaApparato(String id, ValoreDiStato nuovo) throws Exception{
    apparati.getApparato(id).comanda(nuovo);
    
  }
  
  public void comandaTutti(ValoreDiStato nuovo){
    for(Apparato a:apparati){
      a.comanda(nuovo);
    }
  }
  
  public ValoreDiStato getStatoApparato(String id) throws Exception{
    return apparati.getApparato(id).getStato();
  }
  
//  public String[] getStoriaAzioni() {
//    return null;
//  }
  

  @Override
  public String toString() {
    return "ControlloOperativo{" + "apparati=" + apparati + '}';
  }
  
  
}
