/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package model;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.logging.Level;

/**
 *
 * @author ragno
 */
public class ControlloOperativoAdvanced extends ControlloOperativo {
  private static String LOGPATH="dati/log.txt";
  private Logger log;

  public ControlloOperativoAdvanced() throws IOException {
    super();
    log=new Logger(new File(LOGPATH));
  }

  @Override
  public void comandaApparato(String id, ValoreDiStato nuovo) throws Exception {
    super.comandaApparato(id, nuovo);
    log.append("comandaApparato id="+id+" nuovo="+nuovo);
  }

  @Override
  public void comandaTutti(ValoreDiStato nuovo) {
    super.comandaTutti(nuovo);
    log.append("comandaTutti nuovo="+nuovo);
  }

  @Override
  public ValoreDiStato getStatoApparato(String id) throws Exception {
    ValoreDiStato st= super.getStatoApparato(id);
    log.append("getStatoApparato id="+id+" stato="+st);
    return st;
  }

//  @Override
  public String[] getStoriaAzioni() {
    String[] ret =new String[1000];
    int i=0;
    for (String line:log){
//        System.out.println(line);
        ret[i++]=line;        
    }
    return ret;
  }
  
}
