package model.lib;

/**
 *
 * @author docente
 */
public interface Crud<K extends Comparable,V extends ObjectWithKey<K>> {
    public void create(V value) throws Exception;
    public V read(K key) throws Exception;
    public void update(V value) throws Exception;
    public void delete(K key) throws Exception;
}
